#!/usr/bin/env node

'use strict';
const program = require('commander');
const build = require('../runner/build');
program
    .option(
        '-e, --entry [entry]',
        'entry files (,) separated, glob mode , need to quote',
        val => {
            return val.split(',');
        }, ['index.html']
    )
    .option('--cdn [cdn]', 'static cdn domain')
    .option('--min [min]', 'min file', true)
    .option('--config [config]', 'config file , default ".ksr.conf.js"', '.ksr.conf.js')
    .option('-s, --static [static]', `static dir , 逗号分隔 , 默认是当前目录下的dist`, val => {
        return val.split(',');
    }, ['dist'])
    .parse(process.argv);

build(program);