const chalk = require("chalk");
const _ = require("lodash");
const fs = require("fs");
const path = require("path");
const globby = require("globby");

module.exports = function(entry, ksr) {
  if (!entry || entry.length <= 0) {
    console.log(
      chalk.red(
        "需要存在一个入口文件 , 默认为当前目录下的index.[html|ejs],与index.js , 入口文件[html,js]名称必须一致"
      )
    );
    return [];
    process.exit(1);
  }
  const pathConvert = ksr.pathConvert;
  const entrys = _.reduce(
    entry,
    (files, file) => {
      const finds = globby.sync(pathConvert(file));
      Array.prototype.push.apply(files, _.isArray(finds) ? finds : []);
      return files;
    },
    []
  );

  const cwd = process.cwd();
  const result = _.reduce(
    entrys,
    function(files, file) {
      const _path = pathConvert(file);
      try {
        let statPath;

        try {
          statPath = fs.statSync(_path);
        } catch (error) {}

        const extname = path.extname(_path);
        const basename = path.basename(_path, extname);
        const relative = path.relative(cwd, file);
        const relative_dir = path.dirname(relative);
        const dirname = path.dirname(_path);
        const obj = {};
        if (!statPath || !statPath.isFile()) {
          return;
        }
        obj["basename"] = basename;
        obj["chunk"] = `__${relative.replace(/\/|\\/g, "_")}__`;
        obj["relative"] = relative.replace(/\/|\\/g, "/");
        obj["relative_dir"] = relative_dir.replace(/\/|\\/g, "/");
        if (extname === ".js") {
          obj["js"] = _path;
        }
        if (extname === ".ts") {
          obj["ts"] = _path;
        }

        if (extname === ".html" || extname === ".ejs") {
          obj["template"] = `!!ejs-loader!${_path}`;
          obj["template_path"] = `${_path}`;
          obj["filename"] = relative;
          const js = path.resolve(dirname, `${basename}.js`);
          let statJS;
          try {
            statJS = fs.statSync(js);
          } catch (error) {}
          if (statJS && statJS.isFile()) {
            obj["js"] = js;
          }
          const ts = path.resolve(dirname, `${basename}.ts`);
          let statTS;
          try {
            statTS = fs.statSync(ts);
          } catch (error) {}
          if (statTS && statTS.isFile()) {
            obj["ts"] = ts;
          }
        }
        if (!_.isEmpty(obj)) {
          files.push(obj);
        }
      } catch (error) {
        console.error(`自动解析入口失败${chalk.red(error)}`);
        process.exit(1);
      }
      return files;
    },
    []
  );

  if (result.length <= 0) {
    console.log(
      chalk.red(
        "Error : 需要存在一个入口文件 , 默认为当前目录下的index.[html|ejs],与index.js , 入口文件[html,js]名称必须一致"
      )
    );
    process.exit(1);
    return [];
  }
  return result;
};
